unit ActivationObjet;

interface

function GetObject(GUID: TGUID): IUnknown;

implementation

uses ActiveX, ComObj;

function GetObject(GUID: TGUID): IUnknown;
var
  BindCtx: IBindCtx;
  Moniker: IMoniker;
  chEaten: Integer;
  DisplayName: string;
  PDisplayName: PWideChar;
const
  IID_IUnknown: TGUID = (
    D1:$00000000;D2:$0000;D3:$0000;D4:($C0,$00,$00,$00,$00,$00,$00,$46));
begin
  DisplayName := GUIDToString(GUID);
  Delete(DisplayName, 1, 1);
  Delete(DisplayName, Length(DisplayName), 1);
  Insert('clsid:', DisplayName, 1);

  CreateBindCtx(0, BindCtx);
  PDisplayName := StringToOleStr(DisplayName);
  OleCheck(MkParseDisplayName(BindCtx, PDisplayName, chEaten, Moniker));
  SysFreeString(PDisplayName);

  OleCheck(Moniker.BindToObject(BindCtx, nil, IID_IUnknown, Result));
  Result._AddRef;
end;

end.
