unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Project1_TLB;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    Test: ITest;
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

uses ActivationObjet;

{$R *.dfm}

// Mthode de TForm1

procedure TForm1.Button1Click(Sender: TObject);
var
  TestFactory: ITestFactory;
begin
  TestFactory := GetObject(CLASS_Test) as ITestFactory;
  Test := TestFactory.CreateTest(Edit1.Text);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if Test <> nil then
    ShowMessage('Message : ' + Test.Message);
end;

end.
